//Demoprogramm zur richtigen Verwendung von TspinEdit
// http://www.lazarusforum.de/viewtopic.php?f=5&t=10867

// Es soll ein Widerstandswert eingegeben werden können.
// Per Tastatur (edit) und per Mausrad (change)
// Verbesserungen sind erwünscht

// 08.07.2017




unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Spin, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    btnDisplay: TButton;
    chkBerErlaubt: TCheckBox;
    edtSpannung: TEdit;
    edtStrom: TEdit;
    FltEdtWiderstand: TFloatSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;

    Memo1: TMemo;

    procedure btnDisplayClick(Sender: TObject);
    procedure FltEdtWiderstandChange(Sender: TObject);
    procedure FltEdtWiderstandEditingDone(Sender: TObject);
    procedure FltEdtWiderstandKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

  StromI      : Real;
  SpannungU   : Real;
  WiderstandR : Real;

  RechnenErlaubtStatus : Boolean;

implementation

{$R *.lfm}

{ TForm1 }

//********************************
//  Proc : Berechnung
//********************************
procedure Berechnung;
begin
   form1.Memo1.Lines.Add('Berechnung mit Wert : '+FormatFloat('###,##0.00',WiderstandR));
   StromI := SpannungU / WiderstandR;
end;

//********************************
//  Proc : Display Values
//********************************
procedure TForm1.btnDisplayClick(Sender: TObject);
begin
  edtSpannung.caption :=  FormatFloat('###,##0.00',SpannungU);
  FltedtWiderstand.value :=  WiderstandR;
  edtStrom.caption :=  FormatFloat('###,###0.000',StromI);
  form1.Memo1.Lines.Add('****** Berechnet ******');
end;

//********************************
//  Proc : Change (Mausrad)
//********************************
procedure TForm1.FltEdtWiderstandChange(Sender: TObject);
begin
   if not RechnenErlaubtStatus then begin
     form1.Memo1.Lines.Add('FloatSpinEdit : Berechnung nicht erlaubt');
     chkBerErlaubt.Checked := RechnenErlaubtStatus;
     exit;     //hier Prozedur verlassen
   End;

   form1.Memo1.Lines.Add('FloatSpinEdit : Berechnung ist erlaubt');
   form1.Memo1.Lines.Add('FloatSpinEdit OnChange : '+FormatFloat('###,##0.00',FltEdtWiderstand.Value));
   WiderstandR := FltEdtWiderstand.value;
   Berechnung;

   RechnenErlaubtStatus := true;
   chkBerErlaubt.Checked := RechnenErlaubtStatus;
end;

//********************************
//  Proc : Editing Done (Tastatur)
//********************************
procedure TForm1.FltEdtWiderstandEditingDone(Sender: TObject);
begin
  form1.Memo1.Lines.Add('FloatSpinEdit EditingDone : '+FormatFloat('###,##0.00',FltEdtWiderstand.Value));
  FltEdtWiderstand.value :=  FltEdtWiderstand.Value;   //wird gebraucht um korrigierte Werte sofort korrigiert darzustellen (nicht innerhalb min-max)
  WiderstandR := FltEdtWiderstand.value;
  Berechnung;
  RechnenErlaubtStatus := true;
end;

//********************************
//  Proc : KeyDown
//********************************
procedure TForm1.FltEdtWiderstandKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  form1.Memo1.Lines.Add('Erreigniss : Key Down');
  RechnenErlaubtStatus := (Key = VK_UP) or (Key = VK_DOWN);  // VK_UP und VK_DOWN benötigen LCLType in "uses"
  chkBerErlaubt.Checked := RechnenErlaubtStatus;
end;

//********************************
//  Proc : Form Create
//********************************
procedure TForm1.FormCreate(Sender: TObject);
begin
  RechnenErlaubtStatus := true;   // alternativ: gleich bei der Deklaration auf true setzen
  chkBerErlaubt.Checked := RechnenErlaubtStatus;
  SpannungU := 12.00;
  WiderstandR := 1000;
  StromI := 0.00;
  Berechnung;
  btnDisplay.Click;
end;


end.

